#include <SoftwareSerial.h>

//Ethernet unit xbee stand-alone arduino sketch - openenergymonitor.org GPL
//Author: Trystan Lea



//Xbee serial connection.
SoftwareSerial xbeeSerial(2, 3);

//Character array used to convert recieved serial characters to floats.
char cArray[10];
int ic=0;

double realPower = 0, 
       apparentPower = 0,
       powerFactor = 0,
       Vrms = 0,
       Irms = 0,
       Freq = 0;

//Used to determine significant change - detailed below.
int currentValue, lastValue, secondLastValue;

int lastValueSent;
//Significant change of more than 20W in this case.
int differenceThreshold = 20;


void setup()   {                
  
  Serial.begin(9600);  
  
  xbeeSerial.begin(9600);

  delay(1000);
  
}

//Reads in data from xbee, converting the character stream to floats.
int readXbeeData()
{
   int done = 0;
   
   int inByte;
  
   while (xbeeSerial.available() > 0) 
   {
      //Read in a byte
      inByte = xbeeSerial.read();

      //Serial.print((char)inByte);
    
      //Each value send is marked with a character
      //atof converts the character array to a float.
      if (inByte=='A') realPower = atof(cArray);
      if (inByte=='B') apparentPower = atof(cArray);
      if (inByte=='C') powerFactor = atof(cArray);
      if (inByte=='D') Vrms = atof(cArray);
      if (inByte=='E') Irms = atof(cArray);
      if (inByte=='F') {Freq = atof(cArray); done = 1;}
      
      //If the recieved byte is a digit (specified by ASCII values 65 to 90)
      if (inByte>64 && inByte<91) 
      {
         ic=0;
         for(int i=0; i<10; i++) cArray[i] = 0;
      }

      //If the recieved byte is a digit (specified by ASCII values 65 to 90)
      //or a decimal point ASCII 46
      if ((inByte>47 && inByte<58) || inByte==46)   
      {
         //add to character array
         cArray[ic] = inByte; ic++;
      }
   }
   
   //Return status
   return done;
}


void loop()                     
{

   if (readXbeeData()==1)
   {
      Serial.print(realPower);
      Serial.print(" ");   
      Serial.print(apparentPower);
      Serial.print(" ");   
      Serial.print(powerFactor);
      Serial.print(" ");   
      Serial.print(Vrms);
      Serial.print(" ");   
      Serial.print(Irms);
      Serial.print(" ");   
      Serial.println(Freq);
   }
 
}
